Development
-----------

# Commands

## Reinstall YAML form module.

    drush yamlform-purge --all -y; drush pmu -y yamlform_test; drush pmu -y  yamlform; drush en -y yamlform; drush en -y yamlform_test;

    drush php-eval 'module_load_include('install', 'yamlform'); yamlform_uninstall();'
    drush yamlform-purge --all -y; drush pmu -y yamlform_test; drush pmu -y  yamlform; 
    drush en -y yamlform; drush en -y yamlform_test;

## Install extra modules.

    drush en -y yamlform captcha honeypot select_or_other

## Create test roles and users.

    drush role-create developer
    drush role-add-perm developer 'view the administration theme,access toolbar,access administration pages,access content overview,access yamlform overview,administer yamlform,administer blocks,administer nodes'
    drush user-create developer --password="developer"
    drush user-add-role developer developer
    
    drush role-create admin
    drush role-add-perm admin 'view the administration theme,access toolbar,access administration pages,access content overview,access yamlform overview,administer yamlform submission'
    drush user-create admin --password="admin"
    drush user-add-role admin admin

    drush role-create manager
    drush role-add-perm manager 'view the administration theme,access toolbar,access administration pages,access content overview,access yamlform overview'
    drush user-create manager --password="manager"
    drush user-add-role manager manager

    drush role-create user
    drush user-create user --password="user"
    drush user-add-role user user

## Create test submissions for 'Contact' and 'Example: Inputs' form.

    drush yamlform-generate contact
    drush yamlform-generate example_inputs

## Test update hooks

    drush php-eval 'module_load_include('install', 'yamlform'); ($message = yamlform_update_8001()) ? drupal_set_message($message) : NULL;'
    
## Access developer information

    drush role-add-perm anonymous 'access devel information'
    drush role-add-perm authenticated 'access devel information'

 d
# Code Sources and Design Patterns

Below is just a reference to where most of the code snippets and/or 
design pattern were taken from to build this module.
 
- UI/Naming convention: Webform module (Copied)
- YamlForm to YamlFormSubmission bundle: Vocabulary to Term entities
- YamlFormSubmission entity_type and entity_id: Comment entity
- YamlFormSubmission preview: CommentForm
- YamlFormHandler plugin: ImageEffect
- YamlFormEntityReferenceItem field type: FileItem
