<?php

/**
 * @file
 * Contains \Drupal\yamlform\Plugin\YamlFormElement\ContainerBase.
 */

namespace Drupal\yamlform\Plugin\YamlFormElement;

use Drupal\yamlform\YamlFormElementBase;

/**
 * Provides a base 'container' class.
 */
abstract class ContainerBase extends YamlFormElementBase {

  /**
   * {@inheritdoc}
   */
  public function buildHtml(array &$element, $value) {
    $build = [];
    if (isset($element['#title'])) {
      $build['#type'] = 'details';
      $build['#title'] = $element['#title'];
      $build['#open'] = TRUE;
    }
    $build['items'] = $value;
    return $build;
  }

  /**
   * {@inheritdoc}
   */
  public function buildText(array &$element, $value) {
    $build = ['#prefix' => "\n", '#suffix' => "\n"];
    if ($element['#title']) {
      $build['title'] = [
        '#markup' => strtoupper($element['#title']),
        '#suffix' => "\n" . str_repeat('-', strlen($element['#title'])) . "\n",
      ];
    }
    $build['items'] = $value;
    return $build;
  }

}
