<?php

/**
 * @file
 * Contains \Drupal\yamlform\Plugin\YamlFormElement\TextField.
 */

namespace Drupal\yamlform\Plugin\YamlFormElement;

use Drupal\yamlform\YamlFormElementBase;
use Drupal\yamlform\YamlFormSubmissionInterface;

/**
 * Provides a 'textfield' element.
 *
 * @YamlFormElement(
 *   id = "textfield",
 *   label = @Translation("TextField"),
 *   description = @Translation("Handles defining default properties of a text field element.")
 * )
 */
class TextField extends YamlFormElementBase {

  /**
   * {@inheritdoc}
   */
  public function prepare(array &$element, YamlFormSubmissionInterface $yamlform_submission) {
    $element['#maxlength'] = (!isset($element['#maxlength'])) ? 255 : $element['#maxlength'];

    // Convert custom #autocomplete property to a FAPI autocomplete route
    // that return YAML form options.
    if (isset($element['#autocomplete'])) {
      $element['#autocomplete_route_name'] = 'yamlform.options_autocomplete';
      $element['#autocomplete_route_parameters'] = [
        'yamlform' => $yamlform_submission->getYamlForm()->id(),
        'key' => $element['#key'],
      ];
    }
  }

}
